class BubbleSort {	
	static int cmp_cnt = 0;
	static int xch_cnt = 0;
    	static boolean less(ITEM v, ITEM w) {
		return v.less(w);
	}
    	static void exch(ITEM[] a, int i, int j) {
		ITEM t = a[i];
		a[i] = a[j];
		a[j] = t;
		xch_cnt++;
	}
    	static void compExch(ITEM[] a, int i, int j) {
		cmp_cnt++;
		if (less(a[j], a[i]))
			exch (a, i, j);
	}
	static void sort(ITEM[] a, int l, int r) {
		bubble(a, l, r);
	}
	static void bubble(ITEM[] a, int l, int r) {
		for (int i = l; i < r; i++)
      			for (int j = r; j > i; j--)
        			compExch(a, j-1, j);
  	}
    	public static void main(String[] args) {
		int N = 0;

		try {
			N = Integer.parseInt(args[0]);
		} catch (Exception e) {
			Out.println("usage java BubbleSort #elem");
			System.exit(1);
		}
        	myItem a[] = new myItem[N];

        	for (int i = 0; i < N; i++) {
			a[i] = new myItem();
			a[i].rand();
		}
        	sort(a, 0, N-1);
        	if (N < 100)
          		for (int i = 0; i < N; i++) 
            			Out.println(a[i] + "");
        	Out.println("Compares used: " + cmp_cnt);
        	Out.println("Exchanges used: " + xch_cnt);
      }
}
